/* COADA 
 * 
 * Principiul Cozii: FIFO (First In - First Out)
 * 
 * Este o structura de date LINIARA (sir, queue)
 * care admite 2 operatii:
 * 
 * 1. Adauga un element la sfarsitul cozii (push(x))
 * 2. Sterge primul element al cozii (sterge capul cozii) pop()
 */ 
 
// Implementare cu sir

#include <iostream>
#include <queue>
#include <string>
using namespace std;

 
int main()
{
	queue<int> Q; // declar o stiva vida
	
	Q.push(10); Q.push(20); Q.push(30); Q.push(40); 
	
	while (!Q.empty())
	{
		cout << Q.front() << ' '; // afisam primul elem din coada
		Q.pop();                  // stergem primul elem din coada
	}
	
	return 0;
}

