/* Stiva 
 * 
 * Principiul Stivei: LIFO (Last In First Out)
 * Este o structura de date LINIARA (sir)
 * care admite 2 operatii:
 * 
 * 1. Adauga un element in varful stivei  (push(x))
 * 2. Sterge elementul din varful stivei (pop())
 *
 */ 
// Implementare cu stack<T> din STL

#include <iostream>
#include <stack>
using namespace std;


int main()
{
	stack<int> stk; // declar o stiva vida
	
	cout << "Stiva are " << stk.size() << " elemente\n";
	stk.push(10);
	stk.push(20);
	stk.push(30);
	stk.push(40);
	stk.push(50);
	
	while (!stk.empty())
	{
		cout << stk.top() << '\n';
		stk.pop();  // "stergem" elem din varful stivei
	}
	
	return 0;
}

