/* Stiva 
 * 
 * Principiul Stivei: LIFO (Last In First Out)
 * 
 * Este o structura de date LINIARA (sir)
 * care admite 2 operatii:
 * 
 * 1. Adauga un element in varful stivei  (push(x))
 * 2. Sterge elementul din varful stivei (pop())
 *
 */ 
// Implementare cu sir
#include <iostream>
using namespace std;


int stk[1000];
int n = 0; // nr de elem din stiva (poz elem din varful stivei)

// operatiile cu stiva
void push(int x);
void pop();

// functii de informare
bool empty();  // returnaza true daca stiva este vida
int top();    // returneaza elementul din varful stivei

int main()
{
	push(10);
	push(20);
	push(30);
	push(40);
	push(50);
	
	while (!empty())
	{
		cout << top() << '\n';
		pop();
	}
	
	return 0;
}

void push(int x)
{
	stk[++n] = x;
}

void pop()
{
	n--;
}

bool empty()
{
	return n == 0;
}

int top()
{
	return stk[n];
}
