/* Stiva 
 * 
 * Principiul Stivei: LIFO (Last In First Out)
 * 
 * Este o structura de date LINIARA (sir)
 * care admite 2 operatii:
 * 
 * 1. Adauga un element in varful stivei  (push(x))
 * 2. Sterge elementul din varful stivei (pop())
 *
 */ 
// Implementare cu stack<T> din STL

#include <iostream>
#include <stack>
#include <string>
using namespace std;


int main()
{
	stack<string> stk; // declar o stiva vida pt elemente de tip string
	
	stk.push("Ionel");
	stk.push("Marcel");
	stk.push("Viorel n-a venit acasa");
	stk.push("Daniel");
	stk.push("Ghiocel");
	
	while (!stk.empty())
	{
		cout << stk.top() << '\n';
		stk.pop();  // "stergem" elem din varful stivei
	}
	
	return 0;
}

